<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
	<head>
		<title><?php echo _tr('Install.TITLE', 'SilverStripe CMS Installation');?></title>
		<script type="text/js">
			function show(id) {
				document.getElementById(id).style.display = '';
			}
			function hide(id) {
				document.getElementById(id).style.display = 'none';
			}
		</script>
		<link rel="stylesheet" type="text/css" href="themes/blackcandy/css/layout.css" />
		<link rel="stylesheet" type="text/css" href="themes/blackcandy/css/typography.css" />
		<link rel="stylesheet" type="text/css" href="themes/blackcandy/css/form.css" />
		<link rel="stylesheet" type="text/css" href="install/config-form.css" />
		<link rel="shortcut icon" href="favicon.ico" />
	</head>

	<body><form action="install.php" method="post">
		<div id="BgContainer">
			<div id="Container">
				<div id="Header">
					<h1><?php echo _tr('Install.TITLE', 'SilverStripe CMS Installation');?></h1>
                    
					<p><?php echo _tr('Install.VERSION', 'Version');?> <?php echo $silverstripe_version; ?>
                    
                   </p>
				</div>
				
				<div id="Navigation">&nbsp;</div>
				<div class="clear"><!-- --></div>
				
				<div id="Layout">
					<div class="typography">
                    <span style="float:right;">
                            <select id="install_language" name="install_language" class="text" onChange="this.form.submit()" >
                                <?php echo $language->getInstallLocaleOptions(); ?>
                            </select>
                   </span>
						<h1><?php echo _tr('Install.WELCOME', 'Welcome to SilverStripe');?></h1>
                        
						<p><?php echo _tr('Install.WELCOMETEXT', 'Thanks for choosing to use SilverStripe!  Please follow the instructions below to get SilverStripe installed.');?></p>
			
						
  
							<?php if(isset($hasErrorOtherThanDatabase)) { ?>
								<p class="error">
                                <?php echo _tr('Install.HASERROROTHERTHENDB', 'You aren\'t currently able to install the software.');?>
                                     <?php echo _tr('Install.HASERRORMOREINFO', 'Please <a href="#requirements">see below</a> for details.<br />
									If you are having problems meeting the requirements, see the <a href="http://doc.silverstripe.org/doku.php?id=server-requirements">server requirements wiki page</a>.');?>
									
								</p>
                            <? //} else if($dbReq->hasErrors()){ ?>    
							<?php } else { ?>
								<?php if($req->hasWarnings()) { ?>
									<p class="warning">
                                     <?php echo _tr('Install.HASERROR', 'There are some issues that we recommend you look at before installing, however, you are still able to install the software.');?>
										<?php echo _tr('Install.HASERRORMOREINFO', 'Please <a href="#requirements">see below</a> for details.<br />
									If you are having problems meeting the requirements, see the <a href="http://doc.silverstripe.org/doku.php?id=server-requirements">server requirements wiki page</a>.');?>
									</p>
								<?php } else if(!$dbReq->hasErrors()) { ?>
									<p class="good">
										
                                        <?php echo _tr('Install.READY', 'You\'re ready to install! &nbsp;&nbsp; ');?>
									</p>
								<?php } ?>		
                               			
								<p>
									<b><?php echo _tr('Install.THEME', 'Template to install:');?></b>
								</p>
								<ul id="Themes">
									<li><input type="radio" name="template" value="blackcandy" id="BlackCandy" checked="checked" /><label for="BlackCandy">BlackCandy, <?php echo _tr('Install.DEFAULTTHEME', 'default template ready to use.');?></label></li>
									<li><input type="radio" name="template" value="tutorial" id="EmptyTemplate" /><label for="EmptyTemplate"><?php echo _tr('Install.EMPTYTHEME', 'Empty template, ready to begin the <a href="http://doc.silverstripe.org/doku.php?id=tutorials">tutorial</a>.');?></label></li>
								</ul>
								<p><?php echo _tr('Install.THEMEINFO', 'You can change the template or download another from the <a href="http://silverstripe.org/themes/">SilverStripe website</a> after installation.');?></p>
			
								<input type="checkbox" id="stats" name="stats" checked="checked"><label for="stats"><?php echo _tr('Install.SENDINFO', 'Send information on my webserver to SilverStripe (this is only version information, used for statistical purposes)');?></label><br />
								
								
								<?php if($alreadyInstalled) { ?>
									<p class="warning">
                                    <?php echo _tr('Install.ALLREADYINSTALLED', '<strong>Note:</strong> It seems as though SilverStripe is already installed here.  If you ask me to install, I will overwrite the <strong>.htaccess</strong> and <strong>mysite/_config.php</strong> files.');?>
										
										<br />
									<input type="checkbox" id="ReIn" name="force_reinstall" onclick="document.getElementById('install_button').disabled = !this.checked" /><label for="ReIn"><?php echo _tr('Install.INSTALLOK', 'That\'s okay, please re-install SilverStripe and overwrite these files.');?></label>
									</p>
								<?php } ?>
			
								<p>
									<?php if($alreadyInstalled) { ?>
										<input id="install_button" type="submit" disabled="disabled" class="action" name="go" value="<?php echo _tr('Install.INSTALL', 'Install SilverStripe'); ?>" onclick="document.getElementById('saving_top').style.display = ''; this.value = '<?php echo _tr('Install.INSTALLING', 'Installing SilverStripe...'); ?>'" />
									<?php } else { ?>
									<input id="install_button" type="submit" class="action" name="go" value="<?php echo _tr('Install.INSTALL', 'Install SilverStripe'); ?>" onclick="document.getElementById('saving_top').style.display = ''; this.value = '<?php echo _tr('Install.INSTALLING', 'Installing SilverStripe...'); ?>'" />
									<?php } ?>
									
									<span id="saving_top" style="display: none">
										&nbsp;
										<img src="cms/images/network-save.gif" />
										(<?php echo _tr('Install.TAKEAMINUTE', 'this will take a minute or so');?>)
									</span>
								</p>
							<?php } ?>
			
							<input type="hidden" name="database" value="MySQLDatabase" />
							<h4>MySQL Database</h4>			
							<?php if($dbReq->hasErrors()) { ?>
								<p class="error"><!--  class="error" -->
                                	<?php echo _tr('Install.DBERROR', 'These database details don\'t appear to be correct.  Please enter the correct details before installing.');?>
								</p>
							<?php } else { ?>
								<p class="good">
									<?php echo _tr('Install.DBOK', 'These database details look all good!');?>
                                   
								</p>
							<?php } ?>

							<p id="mysql_credentials">
								<label for="mysql_server">MySQL <?php echo _tr('Install.MYSQLSERVER', 'server');?>:</label>
								<span class="middleColumn"><input id="mysql_server" class="text" type="text" name="mysql[server]" value="<?php echo $databaseConfig['server']; ?>" /></span>
								<label for="mysql_username">MySQL <?php echo _tr('Install.MYSQLUSER', 'username');?>:</label>
								<span class="middleColumn"><input id="mysql_username" class="text" type="text" name="mysql[username]" value="<?php echo $databaseConfig['username']; ?>"  /></span>
								<label for="mysql_password">MySQL <?php echo _tr('Install.MYSQLPASS', 'password');?>:</label>
								<span class="middleColumn"><input id="mysql_password" class="text" type="password" name="mysql[password]" value="<?php echo $databaseConfig['password']; ?>" /></span>
								<label for="mysql_database">MySQL <?php echo _tr('Install.MYSQLDB', 'database');?>:</label>
								<span class="middleColumn"><input id="mysql_database" class="text" type="text" name="mysql[database]" value="<?php echo $databaseConfig['database']; ?>" onchange="this.value = this.value.replace(/[^A-Za-z0-9_]+/g,'');" /></span>
								<input type="submit" class="action" value="<?php echo _tr('Install.CHECKREQ', 'Re-check requirements');?>" />
							</p>
							<p class="mysql"><?php echo _tr('Install.MYSQLINFO', 'SilverStripe stores its content in a MySQL database.  Please provide the username and password to connect to the server here.  If this account has permission to create databases, then we will create the database for you; otherwise, you must give the name of a database that already exists.');?></p>
							<div class="clear"><!--  --></div>
							<h5>Details</h5>
							<?php $dbReq->showTable("MySQL Configuration"); ?>
			
							<br />
			
							<h4><?php echo _tr('Install.SELECTLANG', 'SilverStripe Language');?></h4>
			
							<p id="Language">
								<label for="admin_username"><?php echo _tr('Install.LANG', 'Language');?>:</label>
								<span class="middleColumn">
                                	<select id="site_language" name="site_language" class="text" >
                                    	<?php echo $language->getSiteLocaleOptions(); ?>
                                    </select>
                                </span>

							</p>
							<p class="adminAcc">
                            	<?php echo _tr('Install.LANGINFO', 'Silverstripe will be installed in the selected language.');?>
								
							</p>
			
							<br />
                            
                            <h4><?php echo _tr('Install.ADMINACCOUNT', 'SilverStripe Administration Account');?></h4>
			
							<p id="AdminAccount">
								<label for="admin_username"><?php echo _tr('Install.ADMINEMAIL', 'Administrator email');?>:</label>
								<span class="middleColumn"><input type="text" class="text" name="admin[username]" id="admin_username" value="<?php echo $adminConfig['username']; ?>" /></span>
								<label for="admin_password"><?php echo _tr('Install.ADMINPASS', 'Administrator password');?>:</label>
								<span class="middleColumn"><input type="text" class="text" name="admin[password]" id="admin_password" value="<?php echo $adminConfig['password']; ?>" /></span>
								<label for="admin_firstname"><?php echo _tr('Install.ADMINFIRSTNAME', 'Administrator first name');?>:</label>
								<span class="middleColumn"><input type="text" class="text" name="admin[firstname]" id="admin_firstname" value="<?php echo $adminConfig['firstname']; ?>" /></span>
								<label for="admin_surname"><?php echo _tr('Install.ADMINSURNAME', 'Administrator surname');?>:</label>
								<span class="middleColumn"><input type="text" class="text" name="admin[surname]" id="admin_surname" value="<?php echo $adminConfig['surname']; ?>" /></span>
							</p>
							<p class="adminAcc">
                            	<?php echo _tr('Install.ADMININFO', 'We will set up 1 administrator account for you automatically.  Enter the email address and password.  If you\'d rather log-in with a username instead of an email address, enter that instead.');?>
							</p>
			
							<br />
							
							<h4><?php echo _tr('Install.DEVSITES', 'Development Servers');?></h4>
							<p id="DevSites">
								<label for="devsites"><?php echo _tr('Install.DEVSITES', 'Development servers');?>:</label>
								<span class="middleColumn"><textarea name="devsites" id="devsites" rows="5" />localhost
127.0.0.1</textarea></span>
							</p>
							<p class="devHelp">
                            	<?php echo _tr('Install.DEVHELP', 'SilverStripe allows you to run a site in <a href="http://doc.silverstripe.com/doku.php?id=devmode">development mode</a>.
								This shows all error messages in the web browser instead of emailing them to the administrator, and allows
								the database to be built without logging in as administrator. Please enter the host/domain names for servers
								you will be using for development.');?>
								
							</p>
							
							<br />
							
			
							<h4 id="requirements"><?php echo _tr('Install.REQUIREMENTS', 'Requirements');?></h4>
							<?php
								$req->showTable();
				?>
			
						
					</div>
				</div>
				
				<div class="clear"><!-- --></div>
			</div>
			
			<div id="Footer">
				<div class="footerTop"><!-- --></div>
				<p>Copyright &copy; 2007 | Powered by <a href="http://www.silverstripe.org">SilverStripe Open Source CMS</a></p>
			</div>
		</div>
        </form>
	</body>
</html>
